// MTCrash (Multithreaded crash)
// Copyright (c) 2009 Dmitry Vostokov
// GNU GENERAL PUBLIC LICENSE
// http://www.gnu.org/licenses/gpl-3.0.txt

#include <windows.h>
#include <process.h>
#include <iostream>

bool twice = false;

void thread_one(void *)
{
	Sleep(1000);
	std::cout << "Thread 1 is about to experience an AV exception..." << std::endl;
	*(int *)NULL = 0;
}

void thread_two(void *)
{
	Sleep(2000);
	if (twice) 
	{
		std::cout << "Thread 2 is about to experience an AV exception..." << std::endl;
		*(int *)NULL = 0;
	}

	while (true)
	{
		std::cout << "Thread 2 is still running..."  << std::endl;
		Sleep(1000);
	}
}

int main(int argc, WCHAR* argv[])
{
	if (argc > 1) twice = true;
		
	_beginthread(thread_two, 0, NULL);
	_beginthread(thread_one, 0, NULL);
	
	while(true)
	{
		std::cout << "Main Thread is still running..."  << std::endl;
		Sleep(1000);
	}
	
	return 0;
}
